<script setup lang="ts">
  import {reactive, h, ref} from 'vue'
  import katex from 'katex'
  import TheEditor from './components/TheEditor.vue';
  import {defaultToolbarString} from './defaultToolbar';
  import ContentPlaceholderPlugin from './extensions/ContentPlaceholder';
  import ImagePlugin from './extensions/Image';
  import EquationPlugin from './extensions/Equations';
  import {inMemoryImageUploader} from './utilities/image_uploaders';
  import Heading from '@tiptap/extension-heading';
  import ImageUploadDialog from './components/ImageUploadDialog.vue';
  import 'katex/dist/katex.min.css';
  const content = `<h1 style="text-align: center">Heading 1</h1><h2 style="text-align: center">Heading 2</h2><h3 style="text-align: center">Heading 3</h3><p>A paragraph with <strong>Bold</strong>, <em>Italic,</em> <u>Underlines</u>, <s>Strikethrough</s>, <sup>Superscript</sup>, and <sub>Subscript</sub> (as well as a <a target="_blank" rel="noopener noreferrer nofollow" href="https://uwaterloo.ca">Link</a>)</p><ul><li><p>A</p><ul><li><p>Nested</p><ul><li><p>Bullet list</p></li></ul></li></ul></li></ul><ol><li><p>Similarly</p><ol><li><p>Nested</p><ol><li><p>Numerical</p></li><li><p>list</p></li></ol></li></ol></li></ol><table><tbody><tr><th colspan="1" rowspan="1"><p>H1</p></th><th colspan="1" rowspan="1"><p>H2</p></th><th colspan="1" rowspan="1"><p>H3</p></th></tr><tr><td colspan="1" rowspan="1"><p>A simple table</p></td><td colspan="1" rowspan="1"><p>With content in</p></td><td colspan="1" rowspan="1"><p>3 different cells</p></td></tr><tr><td colspan="3" rowspan="1"><p style="text-align: center">And a merged cell</p></td></tr></tbody></table>`
  const small_content = `<p><strong>Hello</strong> <em>World</em></p>`
  const extension_content = `
  <p><strong>Hello</strong> <em>World  </em><span data-raw="\\pi" display-mode="undefined" is-equation="1"><span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">\pi</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span></span></p>`
  const editor_content = reactive({
    default: content,
    remove: content,
    toolbar: small_content,
    extensions: extension_content
  })

  const CustomSpacer = {
    render: () => h('div', {style: 'width: 2rem'}, '~'),
    props: ['editor'],
  }

  const CustomComponent = {
    render: () => h('button', {class: 'the-edit-bar-button', onClick: () => alert('Custom Component!')}, 'Custom'),
    props: ['editor'],
  }

  const image_dialog = ref<InstanceType<typeof ImageUploadDialog>>()
  const open_image_dialog = (editor:any) => {
    image_dialog.value?.openDialog(editor)
  }

  const open_equation_dialog = (editor:any, current) => {
    let eq = prompt("Enter a LaTeX equation", current?.raw);
    if (eq !== null) {
      editor.chain().focus().addEquation({raw: eq}).run();
    }
  }

  const renderImgSrc = (src:string):Promise<string> => {
    return new Promise((resolve, reject) => {
      setTimeout(() => {
        resolve(src)
      }, 10000)
    })
  }

</script>

<template>
  <div>
    <h2>Default Settings</h2>
    <p>By default the editor comes will a collection of extensions and bar items that most people may want and use. Simply enabled with <code>{{ `<the-editor v-model="value" />` }}</code></p>
    <the-editor v-model="editor_content.default" />
    <div class="output"><code><pre>{{ editor_content.default }}</pre></code></div>

    <h2>Disabling Defaults</h2>
    <p>You can disable features AND buttons by removing the relevant tiptap extension. The following editor is initialized with:
      <code>

      {{  `<the-editor v-model="editor_content.remove"
        :disable="[
          'bold',
          'table',
          'textAlign',
          'heading',
          'superscript',
          'subscript',
        ]"
      />`}}
      </code>
    </p>
    <p>Note that the header options auto-remove from the style selector, and heading styles are removed from the output.</p>
    <the-editor v-model="editor_content.remove"
      :disable="[
        'bold',
        'table',
        'textAlign',
        'heading',
        'superscript',
        'subscript',
      ]"
    />
    <div class="output"><code><pre>{{ editor_content.remove }}</pre></code></div>

    <h2>Custom Toolbar Layout and Custom Components</h2>
    <p>You can customize the bar layout by passing a layout string to the editor. This supports spacers and such.</p>
    <p>You can also add custom buttons to the bar by passing "add_bar_components" to the component settings.
      You can even overwrite existing components this way!</p>
    <p><b>NOTE</b> that editing the layout does not remove features, and only changes how the bar looks (i.e removing the bold button won't disable ctrl+b)</p>
    <p><code>{{ `
    ` }}</code></p>
    <the-editor v-model="editor_content.toolbar"
      :extensions="[{controls: {'|': CustomSpacer, 'my-custom-component': CustomComponent}}]"
      toolbar="bold | italic | link | my-custom-component"
    />
    <div class="output"><code><pre>{{ editor_content.toolbar }}</pre></code></div>

    <h2>Adding Extensions</h2>
    <p>You can also add extensions to the editor! Simply provide a list of TipTap extensions to the 'extensions attribute.'</p>
    <p>If you want to also register a component, you can provide a tuple of [extension, {string: component}] to register both at the same time</p>
    <p>Don't forget to alter the layout! You can import defaultToolbar to start with!</p>
    <the-editor v-model="editor_content.extensions"
      :extensions="[
        ImagePlugin({
          openImageDialog: open_image_dialog,
          uploadImage: inMemoryImageUploader({fetchURLs: true}),
        }),
        EquationPlugin({
          openEquationDialog: (ed:any, current) => open_equation_dialog(ed, current),
          renderDisplay: (src)=>katex.renderToString(src, {throwOnError: false}),
        }),
        ContentPlaceholderPlugin({HTMLAttributes:{class: 'pere'}}),
      ]"
      :toolbar="defaultToolbarString + ' | contentPlaceholder | image | equation'"
    />
    <image-upload-dialog ref="image_dialog"/>
    <div class="output"><code><pre>{{ editor_content.extensions }}</pre></code></div>
    <h2>Replacing Extensions</h2>
    <p>You can replace any tiptap extension with a new copy on init.</p>
    <the-editor v-model="editor_content.extensions"
      :extensions="[Heading.configure({levels: [2, 3]})]"
    />

  </div>
</template>